#coding: utf-8

import hashlib
import psutil
import time


def emit(channel, info):
    channel.put(info)


def hash_mountpoint(s):
    md5 = hashlib.md5()
    md5.update(s)
    return md5.hexdigest()


def collect(feed):
    mountpoint_ids = {}

    while True:
        partitions = psutil.disk_partitions()

        for part in partitions:
            # Избегаем постоянного вычисления хэша для известных партиций
            part_hash = mountpoint_ids.setdefault(part.mountpoint, 
                                                  'mount_{0}'.format(hash_mountpoint(part.mountpoint)))

            usage = psutil.disk_usage(part.mountpoint)
            emit(feed, ('{0}.disk.used.bytes'.format(part_hash), usage.used, 'gauge'))
            emit(feed, ('{0}.disk.used.percent'.format(part_hash), usage.percent, 'gauge'))

            time.sleep(15)
